version: "3.9"
services:
  postgresql:
    image: postgres:12-alpine
    restart: unless-stopped
    volumes:
      - authentik-postgres:/var/lib/postgresql/data
    environment:
      - POSTGRES_PASSWORD={{ cloudstack.plugins[plugin].config.db.password }}
      - POSTGRES_USER={{ cloudstack.plugins[plugin].config.db.user }}
      - POSTGRES_DB={{ cloudstack.plugins[plugin].config.db.database }}
    networks:
      - authentik
  
  redis:
    image: redis:alpine
    restart: unless-stopped
    networks:
      - authentik

  server:
    image: ghcr.io/goauthentik/server:{{ cloudstack.plugins[plugin].version }}
    command: server
    container_name: {{ plugin }}
    networks:
      - authentik
{% if cloudstack.plugins[plugin].config.integrations.traefik|bool %}
      - traefik
{% endif %}
    environment:
      AUTHENTIK_REDIS__HOST: {{ cloudstack.plugins[plugin].config.redis.host }}
      AUTHENTIK_POSTGRESQL__HOST: {{ cloudstack.plugins[plugin].config.db.host }}
      AUTHENTIK_POSTGRESQL__USER: {{ cloudstack.plugins[plugin].config.db.user }}
      AUTHENTIK_POSTGRESQL__NAME: {{ cloudstack.plugins[plugin].config.db.database }}
      AUTHENTIK_POSTGRESQL__PASSWORD: {{ cloudstack.plugins[plugin].config.db.password }}
      AUTHENTIK_EMAIL__HOST: {{ cloudstack.plugins[plugin].config.email.host }}
      AUTHENTIK_EMAIL__PORT: {{ cloudstack.plugins[plugin].config.email.port }}
      AUTHENTIK_EMAIL__USERNAME: {{ cloudstack.plugins[plugin].config.email.user }}
      AUTHENTIK_EMAIL__PASSWORD: {{ cloudstack.plugins[plugin].config.email.password }}
      # Use StartTLS
      AUTHENTIK_EMAIL__USE_TLS: "{{ cloudstack.plugins[plugin].config.email.tls }}"
      # Use SSL
      AUTHENTIK_EMAIL__USE_SSL: "{{ cloudstack.plugins[plugin].config.email.ssl }}"
      AUTHENTIK_EMAIL__TIMEOUT: 10
      # Email address authentik will send from, should have a correct @domain
      AUTHENTIK_EMAIL__FROM: {{ cloudstack.plugins[plugin].config.email.user }}
      AUTHENTIK_SECRET_KEY: {{ cloudstack.plugins[plugin].config.secret_key }}
      AUTHENTIK_DEFAULT_USER_CHANGE_EMAIL: "false"
      AUTHENTIK_GDPR_COMPLIANCE: "true"
      AUTHENTIK_FOOTER_LINKS: 
      AUTHENTIK_LOG_LEVEL: debug
    volumes:
      - authentik-media:/media
      - authentik-custom-templates:/templates
      - authentik-geoip:/geoip
    restart: always
{% if cloudstack.plugins[plugin].config.integrations.traefik|bool %}
    labels:
      - "traefik.enable=true"
      - "traefik.docker.network=traefik"
      - "traefik.http.routers.{{ plugin }}.rule=Host(`{{ cloudstack.plugins[plugin].config.sitename }}`)"
      - "traefik.http.routers.{{ plugin }}.entrypoints=web,websecure"
      - "traefik.http.services.{{ plugin }}.loadbalancer.server.port={{ cloudstack.plugins[plugin].config.port }}"
      - 'traefik.http.services.{{ plugin }}.loadbalancer.passhostheader=true'
      - 'traefik.http.routers.{{ plugin }}.service={{ plugin }}'
{% endif %}

  worker:
    image: ghcr.io/goauthentik/server:{{ cloudstack.plugins[plugin].version }}
    restart: unless-stopped
    command: worker
    networks:
      - authentik
    environment:
      AUTHENTIK_REDIS__HOST: {{ cloudstack.plugins[plugin].config.redis.host }}
      AUTHENTIK_POSTGRESQL__HOST: {{ cloudstack.plugins[plugin].config.db.host }}
      AUTHENTIK_POSTGRESQL__USER: {{ cloudstack.plugins[plugin].config.db.user }}
      AUTHENTIK_POSTGRESQL__NAME: {{ cloudstack.plugins[plugin].config.db.database }}
      AUTHENTIK_POSTGRESQL__PASSWORD: {{ cloudstack.plugins[plugin].config.db.password }}
      # AUTHENTIK_ERROR_REPORTING__ENABLED: "true"
      AUTHENTIK_LOG_LEVEL: debug
    # This is optional, and can be removed. If you remove this, the following will happen
    # - The permissions for the /backups and /media folders aren't fixed, so make sure they are 1000:1000
    # - The docker socket can't be accessed anymore
    user: root
    volumes:
      - authentik-backups:/backups
      - authentik-media:/media
      - authentik-certs:/certs
      - authentik-custom-templates:/templates
      - authentik-geoip:/geoip
      - /var/run/docker.sock:/var/run/docker.sock

  geoipupdate:
    image: "maxmindinc/geoipupdate:latest"
    networks:
      - authentik
    volumes:
      - "authentik-geoip:/usr/share/GeoIP"
    environment:
      GEOIPUPDATE_EDITION_IDS: "GeoLite2-City"
      GEOIPUPDATE_FREQUENCY: "8"

  
volumes:
  authentik-postgres:
  authentik-backups:
  authentik-media:
  authentik-certs:
  authentik-custom-templates:
  authentik-geoip:

networks:
{% if cloudstack.plugins[plugin].config.integrations.traefik|bool %}
  traefik:
    external: true
{% endif %}
  authentik:
    name: authentik
